function varargout = GPlan(varargin)
% GPLAN M-file for GPlan.fig
%      GPLAN, by itself, creates a new GPLAN or raises the existing
%      singleton*.
%
%      H = GPLAN returns the handle to a new GPLAN or the handle to
%      the existing singleton*.
%
%      GPLAN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GPLAN.M with the given input arguments.
%
%      GPLAN('Property','Value',...) creates a new GPLAN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GPlan_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GPlan_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GPlan

% Last Modified by GUIDE v2.5 22-Jun-2006 18:19:32
% Written by A. McClung 04/13/05 - Stanford Univ.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GPlan_OpeningFcn, ...
                   'gui_OutputFcn',  @GPlan_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GPlan is made visible.
function GPlan_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GPlan (see VARARGIN)

% Choose default command line output for GPlan
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% Draw the single leg trajectory
UpdateSingleTraj(handles);


% --- Outputs from this function are returned to the command line.
function varargout = GPlan_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Calc.
function Calc_Callback(hObject, eventdata, handles)
% hObject    handle to Calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Turn off the animation button
set(handles.AnimBut,'Value',0);
%Draw the new body and legs
%Reset the plot formatting
newplot(handles.BodyPlot);
cla(handles.BodyPlot);
set(handles.BodyPlot,'XColor','w')
set(handles.BodyPlot,'YColor','w')
set(handles.BodyPlot,'XTickLabel','')
set(handles.BodyPlot,'YTickLabel','')
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;

% Get the GUI editable DC values
loadShearStart = str2num(get(handles.LoadShearStart, 'String'));
loadShearDC = str2num(get(handles.LoadShearDC, 'String'));
strokeStart = str2num(get(handles.StrokeStart, 'String'));
strokeDC = str2num(get(handles.StrokeDC, 'String'));
strideStart = str2num(get(handles.StrideStart, 'String'));
strideDC = str2num(get(handles.StrideDC, 'String'));
nominalStart = str2num(get(handles.NominalStart, 'String'));
nominalDC = str2num(get(handles.NominalDC, 'String'));
liftStart = str2num(get(handles.LiftStart, 'String'));
liftDC = str2num(get(handles.LiftDC, 'String'));
loadNormStart = str2num(get(handles.LoadNormStart, 'String'));
loadNormDC = str2num(get(handles.LoadNormDC, 'String'));
curlStart = str2num(get(handles.CurlStart, 'String'));
curlDC = str2num(get(handles.CurlDC, 'String'));
uncurlStart = str2num(get(handles.UncurlStart, 'String'));
uncurlDC = str2num(get(handles.UncurlDC, 'String'));

% Update the Start and DC times to make them consistent, and then update
% the single leg trajectory graph.
strideStart = max(strideStart, strokeStart);
set(handles.StrideStart, 'String', num2str(strideStart));
strokeDC = min(strokeDC, strideStart - strokeStart);
set(handles.StrokeDC, 'String', num2str(strokeDC));
strideDC = min(strideDC, 1 - strideStart);
set(handles.StrideDC, 'String', num2str(strideDC));

loadNormStart = mod(max(mod(loadNormStart - nominalStart, 1), mod(liftStart - nominalStart, 1)) + nominalStart, 1);
set(handles.LoadNormStart, 'String', num2str(loadNormStart));
nominalDC = min(nominalDC, mod(liftStart - nominalStart, 1));
set(handles.NominalDC, 'String', num2str(nominalDC));
liftDC = min(liftDC, 0.5*mod(loadNormStart - liftStart, 1));
set(handles.LiftDC, 'String', num2str(liftDC));
loadNormDC = min(loadNormDC, mod(nominalStart - loadNormStart, 1));
set(handles.LoadNormDC, 'String', num2str(loadNormDC));

curlDC = min(curlDC, mod(uncurlStart - curlStart, 1));
set(handles.CurlDC, 'String', num2str(curlDC));
uncurlDC = min(uncurlDC, mod(curlStart - uncurlStart, 1));
set(handles.UncurlDC, 'String', num2str(uncurlDC));

% Update handles structure
guidata(hObject, handles);

% Update the single trajectory graph
UpdateSingleTraj(handles);



% get the starting phases
phase(1) = str2num(get(handles.Leg0PhaseOffset, 'String'));
phase(2) = str2num(get(handles.Leg1PhaseOffset, 'String'));
phase(3) = str2num(get(handles.Leg2PhaseOffset, 'String'));
phase(4) = str2num(get(handles.Leg3PhaseOffset, 'String'));

%Plot the body
hold(handles.BodyPlot,'on');
plot(handles.BodyPlot,[-bodyWidth/2 bodyWidth/2 bodyWidth/2 -bodyWidth/2 -bodyWidth/2 ],...
    [-bodyLength/2 -bodyLength/2 bodyLength/2 bodyLength/2 -bodyLength/2],'k')
%Plot the legs (legs must be in pairs, ie. even #)
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    circle5(xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    circle5(-xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    h=text(xpos*1.5,ypos,[num2str(2*(i-1)+1)]);
    set(h,'Parent',handles.BodyPlot);  %Hack to get labels in right window
    h=text(-xpos*1.6,ypos,[num2str(2*(i-1))]);
    set(h,'Parent',handles.BodyPlot);
end
set(handles.BodyPlot,'XLim',[-1,1])
set(handles.BodyPlot,'YLim',[-1,1])
%Draw the new leg temporal maps
newplot(handles.LegTimePlot);
cla(handles.LegTimePlot);
set(handles.LegTimePlot,'XGrid','on');
set(handles.LegTimePlot,'YTickLabel','')
hold(handles.LegTimePlot,'on');
tempSpace=1/(numLegs+1);
c='rgbcmywk';
ylabelpos=0;
ylabeltext='';
%Plot the top and bottom limits on temporal display and fill in w/colors
for i=1:numLegs
    bot=i*tempSpace/(numLegs+1)+(i-1)*tempSpace;
    top=i*tempSpace/(numLegs+1)+i*tempSpace;
    plot(handles.LegTimePlot,[0 1],[bot bot],'k');
    plot(handles.LegTimePlot,[0 1],[top top],'k');
    templeg=fill([0 1 1 0],[bot bot top top],[.67 .67 .67], 'Parent', handles.LegTimePlot);
    set(templeg,'FaceAlpha',.2);
    
    % Add Graphics for Loading Shear
    start = mod(phase(i), 1);
    stop = mod(start + loadShearDC, 1);
    if (start <= stop)
        h = fill([start stop stop start], [bot bot top top], c(2), 'Parent', handles.LegTimePlot);
        set(h, 'FaceAlpha', .5);
    else
        h = fill([1 start start 1], [bot bot top top], c(2), 'Parent', handles.LegTimePlot);
        set(h, 'FaceAlpha', .5);
        h = fill([0 stop stop 0], [bot bot top top], c(2), 'Parent', handles.LegTimePlot);
        set(h, 'FaceAlpha', .5);
    end
    
    % Add Graphics for Stroke    
    start = stop;
    stop = mod(start + strokeDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(3), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(3), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(3), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
    
    % Add Graphics for Stride
    start = mod(phase(i) + strideStart, 1);
    stop = mod(start + strideDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top], c(5), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top], c(5), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top], c(5), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
    
    
    %Add graphics for Toes curling
    start = mod(phase(i) + curlStart, 1);
    stop = mod(start + curlDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(6), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(6), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(6), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
    
    %Add graphics for Toes uncurling
    start = mod(phase(i) + uncurlStart, 1);
    stop = mod(start + uncurlDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(4), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(4), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(4), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
    
    
    %Add graphics for Detachment
    start = mod(phase(i) + liftStart, 1);
    stop = mod(start + liftDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(1), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(1), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(1), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
        
    % Add graphics for Attachment
    start = mod(phase(i) + loadNormStart, 1);
    stop = mod(start + loadNormDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(2), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(2), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(2), 'Parent', handles.LegTimePlot);
        set(h,'FaceAlpha',.5);
    end
    
    ylabelpos(i)=bot+tempSpace/2;
    ylabeltext=[ylabeltext; 'Leg #' num2str(i-1)];
end
set(handles.LegTimePlot,'XLim',[0,1])
set(handles.LegTimePlot,'YLim',[0,1])
set(handles.LegTimePlot,'YTick',ylabelpos)
set(handles.LegTimePlot,'YTickLabel',ylabeltext)


% --- Executes on button press in AnimBut.
function AnimBut_Callback(hObject, eventdata, handles)
% hObject    handle to AnimBut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AnimBut
speedConstant=25;
curtime=0;
timeBar=plot(handles.LegTimePlot,[0 0],[0 1],'k');
set(timeBar,'LineWidth',2);
speed=get(handles.PeriodSlider,'Value');
%Same basic constants as above
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;
tempSpace=1/(numLegs+1);

%Draw the legs for animation
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    Leg(numLegs+1-i)=circle5(xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    Leg(i)=circle5(-xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
end

% Get the color map to use for animating the feet,
f = getframe(handles.LegTimePlot);
height = size(f.cdata,1);
width = size(f.cdata,2);
colormap = f.cdata(round(height/8*[7 5 3 1]), :, :);

%Animate the plots
while get(hObject,'Value')==1
    speed=get(handles.PeriodSlider,'Value');
    curtime=mod(curtime+speed/speedConstant,1);
    set(timeBar,'XData',[curtime curtime]);
    for i=1:numLegs
        % Make the leg the same color as in the time plot
        color = double(colormap(i, round(curtime*width)+1, :))/255;
        color = reshape(color, 1, 3, 1);
        set(Leg(i), 'Color', color);
    end
    pause(0.1);
end
%Clean up animation stuff
if ishandle(timeBar)  %If these have not been cleared, clear them
    delete(timeBar);
    for i=1:numLegs
        delete(Leg(i));
    end
end


function UpdateSingleTraj(handles)
% must be passed the handles structure of the GUI to extract data.

toesUncurl = 0;
toesCurl = 1;
wingDown = 2;
wingNom = 3;
wingUp = 4;
strokeBottom = 5;
loadShear = 6;
strokeTop = 7;

% Get the GUI editable DC values
loadShearStart = str2num(get(handles.LoadShearStart, 'String'));
loadShearDC = str2num(get(handles.LoadShearDC, 'String'));
strokeStart = str2num(get(handles.StrokeStart, 'String'));
strokeDC = str2num(get(handles.StrokeDC, 'String'));
strideStart = str2num(get(handles.StrideStart, 'String'));
strideDC = str2num(get(handles.StrideDC, 'String'));
nominalStart = str2num(get(handles.NominalStart, 'String'));
nominalDC = str2num(get(handles.NominalDC, 'String'));
liftStart = str2num(get(handles.LiftStart, 'String'));
liftDC = str2num(get(handles.LiftDC, 'String'));
loadNormStart = str2num(get(handles.LoadNormStart, 'String'));
loadNormDC = str2num(get(handles.LoadNormDC, 'String'));
curlStart = str2num(get(handles.CurlStart, 'String'));
curlDC = str2num(get(handles.CurlDC, 'String'));
uncurlStart = str2num(get(handles.UncurlStart, 'String'));
uncurlDC = str2num(get(handles.UncurlDC, 'String'));

% Calcuate the time sequences.
strokeTime = mod([0; loadShearDC; strokeStart + strokeDC; strideStart; strideStart + strideDC], 1);
wingTime = mod([nominalStart; nominalStart + nominalDC; liftStart; liftStart + liftDC; loadNormStart - liftDC; loadNormStart; loadNormStart + loadNormDC], 1);
footTime = mod([curlStart; curlStart + curlDC; uncurlStart; uncurlStart + uncurlDC], 1);

% Set value sequences for the graph
strokeVals = [strokeTop loadShear strokeBottom strokeBottom strokeTop]';
wingVals = [wingDown wingNom wingNom wingUp wingUp wingNom wingDown]';
footVals = [toesUncurl toesCurl toesCurl toesUncurl]';


% Now, the time sequences above might not be increasing, so we need to sort
% them and the associated servo value sequences.
[strokeTime, indices] = sort(strokeTime);
strokeVals = strokeVals(indices,:);
[wingTime indices] = sort(wingTime);
wingVals = wingVals(indices,:);
[footTime indices] = sort(footTime);
footVals = footVals(indices,:);

% Add in points for 0 and 1 by interpolating.
l = length(strokeTime);
stroke0Val = (strokeTime(1)*strokeVals(l) +...
    (1 - strokeTime(l))*strokeVals(1))/...
    mod(strokeTime(1) - strokeTime(l), 1);
l = length(wingTime);
wing0Val = (wingTime(1)*wingVals(l) + ...
    (1 - wingTime(l))*wingVals(1))/...
    mod(wingTime(1) - wingTime(l), 1);
l = length(footTime);
foot0Val = (footTime(1)*footVals(l) + ...
    (1 - footTime(l))*footVals(1))/...
    mod(footTime(1) - footTime(l), 1);
strokeTime = [0; strokeTime; 1];
wingTime = [0; wingTime; 1];
footTime = [0; footTime; 1];
strokeVals = [stroke0Val; strokeVals; stroke0Val];
wingVals = [wing0Val; wingVals; wing0Val];
footVals = [foot0Val; footVals; foot0Val];


% Now plot it all
cla(handles.SingleLegTraj);
plot(handles.SingleLegTraj, strokeTime, strokeVals, 'b');
plot(handles.SingleLegTraj, wingTime, wingVals, 'g');
plot(handles.SingleLegTraj, footTime, footVals, 'r');



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on slider movement.
function PeriodSlider_Callback(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

periodBounds=[2 20];  %Bounds for the slider (in secs)
periodslide=1-get(handles.PeriodSlider,'Value');
%set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds)),'%1.2f');
set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds),'%1.2f'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function PeriodSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function Period_Callback(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Period as text
%        str2double(get(hObject,'String')) returns contents of Period as a double

periodBounds=[2 20];  %Bounds for the slider (in secs)
period=str2num(get(handles.Period,'String'));
if period<periodBounds(1)
    period=periodBounds(1);
end
if period>periodBounds(2)
    period=periodBounds(2);
end
set(handles.PeriodSlider,'Value',1-((period-periodBounds(1))/diff(periodBounds)));
set(handles.Period,'String',num2str(period,'%1.2f'));
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Period_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%




function Leg0PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0PhaseOffset as a double

legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
if legphase(1)>=1
    legphase(1)=0;
    set(handles.Leg0PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg0PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1PhaseOffset as a double

legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
if legphase(2)>=1
    legphase(2)=0;
    set(handles.Leg1PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function Leg1PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2PhaseOffset as a double

legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
if legphase(3)>=1
    legphase(3)=0;
    set(handles.Leg2PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg2PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg3PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3PhaseOffset as a double

legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
if legphase(4)>=1
    legphase(4)=0;
    set(handles.Leg3PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg3PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%





function zeroControlVal0_Callback(hObject, eventdata, handles)
% hObject    handle to zeroControlVal0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of zeroControlVal0 as text
%        str2double(get(hObject,'String')) returns contents of zeroControlVal0 as a double


% --- Executes during object creation, after setting all properties.
function zeroControlVal0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to zeroControlVal0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function zeroControlVal1_Callback(hObject, eventdata, handles)
% hObject    handle to zeroControlVal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of zeroControlVal1 as text
%        str2double(get(hObject,'String')) returns contents of zeroControlVal1 as a double


% --- Executes during object creation, after setting all properties.
function zeroControlVal1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to zeroControlVal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function zeroControlVal2_Callback(hObject, eventdata, handles)
% hObject    handle to zeroControlVal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of zeroControlVal2 as text
%        str2double(get(hObject,'String')) returns contents of zeroControlVal2 as a double


% --- Executes during object creation, after setting all properties.
function zeroControlVal2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to zeroControlVal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function zeroControlVal3_Callback(hObject, eventdata, handles)
% hObject    handle to zeroControlVal3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of zeroControlVal3 as text
%        str2double(get(hObject,'String')) returns contents of zeroControlVal3 as a double


% --- Executes during object creation, after setting all properties.
function zeroControlVal3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to zeroControlVal3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function degPerControlVal3_Callback(hObject, eventdata, handles)
% hObject    handle to degPerControlVal3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of degPerControlVal3 as text
%        str2double(get(hObject,'String')) returns contents of degPerControlVal3 as a double


% --- Executes during object creation, after setting all properties.
function degPerControlVal3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to degPerControlVal3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function degPerControlVal2_Callback(hObject, eventdata, handles)
% hObject    handle to degPerControlVal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of degPerControlVal2 as text
%        str2double(get(hObject,'String')) returns contents of degPerControlVal2 as a double


% --- Executes during object creation, after setting all properties.
function degPerControlVal2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to degPerControlVal2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function degPerControlVal1_Callback(hObject, eventdata, handles)
% hObject    handle to degPerControlVal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of degPerControlVal1 as text
%        str2double(get(hObject,'String')) returns contents of degPerControlVal1 as a double


% --- Executes during object creation, after setting all properties.
function degPerControlVal1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to degPerControlVal1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function degPerControlVal0_Callback(hObject, eventdata, handles)
% hObject    handle to degPerControlVal0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of degPerControlVal0 as text
%        str2double(get(hObject,'String')) returns contents of degPerControlVal0 as a double


% --- Executes during object creation, after setting all properties.
function degPerControlVal0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to degPerControlVal0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%




function WingDown3_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown3 as text
%        str2double(get(hObject,'String')) returns contents of WingDown3 as a double


% --- Executes during object creation, after setting all properties.
function WingDown3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown2_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown2 as text
%        str2double(get(hObject,'String')) returns contents of WingDown2 as a double


% --- Executes during object creation, after setting all properties.
function WingDown2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown1_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown1 as text
%        str2double(get(hObject,'String')) returns contents of WingDown1 as a double


% --- Executes during object creation, after setting all properties.
function WingDown1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown0_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown0 as text
%        str2double(get(hObject,'String')) returns contents of WingDown0 as a double


% --- Executes during object creation, after setting all properties.
function WingDown0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom3_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom3 as text
%        str2double(get(hObject,'String')) returns contents of WingNom3 as a double


% --- Executes during object creation, after setting all properties.
function WingNom3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom2_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom2 as text
%        str2double(get(hObject,'String')) returns contents of WingNom2 as a double


% --- Executes during object creation, after setting all properties.
function WingNom2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function WingNom1_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom1 as text
%        str2double(get(hObject,'String')) returns contents of WingNom1 as a double


% --- Executes during object creation, after setting all properties.
function WingNom1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom0_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom0 as text
%        str2double(get(hObject,'String')) returns contents of WingNom0 as a double


% --- Executes during object creation, after setting all properties.
function WingNom0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp3_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp3 as text
%        str2double(get(hObject,'String')) returns contents of WingUp3 as a double


% --- Executes during object creation, after setting all properties.
function WingUp3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp2_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp2 as text
%        str2double(get(hObject,'String')) returns contents of WingUp2 as a double


% --- Executes during object creation, after setting all properties.
function WingUp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp1_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp1 as text
%        str2double(get(hObject,'String')) returns contents of WingUp1 as a double


% --- Executes during object creation, after setting all properties.
function WingUp1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp0_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp0 as text
%        str2double(get(hObject,'String')) returns contents of WingUp0 as a double


% --- Executes during object creation, after setting all properties.
function WingUp0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on button press in WriteDAT2.
function WriteDAT2_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (str2num(get(handles.StrideDC, 'String')) <= 0)
    disp('Return Stroke DC is zero or less.  Please alter the other DC values until there is a positive Return Stroke DC');
    return;
end

servtab=CreateGaitTable(handles, 2);%Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])
%Add the data for all the servos
for i=1:N
    %Write each column of data
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end
fclose(fid);


% --- Executes on button press in WriteDAT3.
function WriteDAT3_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servtab=CreateGaitTable(handles, 3);%Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])

%Enter the proper formatting for ver3 servo controller software to read
fprintf(fid,'Index\r');
fprintf(fid,' %d\r',N);
for i=1:15
    fprintf(fid,' 0\r');
end
fprintf(fid,'Sequence 0\r');

%Add the data for all the servos
for i=1:N
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end

%Enter the proper formatting for ver3 servo controller software to read
for i=1:15
    fprintf(fid,'Sequence %d\r',i);
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% CREATEGAITTABLE will create a table of the servo positions that 
%  correspond to the user defined gait
function dataout=CreateGaitTable(handles, version)

% Get the GUI editable DC and position values
loadShearStart = str2num(get(handles.LoadShearStart, 'String'));
loadShearDC = str2num(get(handles.LoadShearDC, 'String'));
strokeStart = str2num(get(handles.StrokeStart, 'String'));
strokeDC = str2num(get(handles.StrokeDC, 'String'));
strideStart = str2num(get(handles.StrideStart, 'String'));
strideDC = str2num(get(handles.StrideDC, 'String'));
nominalStart = str2num(get(handles.NominalStart, 'String'));
nominalDC = str2num(get(handles.NominalDC, 'String'));
liftStart = str2num(get(handles.LiftStart, 'String'));
liftDC = str2num(get(handles.LiftDC, 'String'));
loadNormStart = str2num(get(handles.LoadNormStart, 'String'));
loadNormDC = str2num(get(handles.LoadNormDC, 'String'));
curlStart = str2num(get(handles.CurlStart, 'String'));
curlDC = str2num(get(handles.CurlDC, 'String'));
uncurlStart = str2num(get(handles.UncurlStart, 'String'));
uncurlDC = str2num(get(handles.UncurlDC, 'String'));

phase(1) = str2num(get(handles.Leg0PhaseOffset, 'String'));
phase(2) = str2num(get(handles.Leg1PhaseOffset, 'String'));
phase(3) = str2num(get(handles.Leg2PhaseOffset, 'String'));
phase(4) = str2num(get(handles.Leg3PhaseOffset, 'String'));

strokeStartAngle = str2num(get(handles.StrokeStartAngle, 'String'))*pi/180;
loadShearAngle = str2num(get(handles.LoadShearAngle, 'String'))*pi/180;
strokeEndAngle = str2num(get(handles.StrokeEndAngle, 'String'))*pi/180;

zeroControlVal(1) = str2num(get(handles.zeroControlVal3, 'String'));
zeroControlVal(2) = str2num(get(handles.zeroControlVal1, 'String'));
zeroControlVal(3) = str2num(get(handles.zeroControlVal2, 'String'));
zeroControlVal(4) = str2num(get(handles.zeroControlVal3, 'String'));

radPerControlVal(1) = -str2num(get(handles.degPerControlVal0, 'String'))*pi/180;
radPerControlVal(2) = -str2num(get(handles.degPerControlVal1, 'String'))*pi/180;
radPerControlVal(3) = str2num(get(handles.degPerControlVal2, 'String'))*pi/180;
radPerControlVal(4) = str2num(get(handles.degPerControlVal3, 'String'))*pi/180;

wingDown(1) = str2num(get(handles.WingDown0, 'String'));
wingDown(2) = str2num(get(handles.WingDown1, 'String'));
wingDown(3) = str2num(get(handles.WingDown2, 'String'));
wingDown(4) = str2num(get(handles.WingDown3, 'String'));

wingNom(1) = str2num(get(handles.WingNom0, 'String'));
wingNom(2) = str2num(get(handles.WingNom1, 'String'));
wingNom(3) = str2num(get(handles.WingNom2, 'String'));
wingNom(4) = str2num(get(handles.WingNom3, 'String'));

wingUp(1) = str2num(get(handles.WingUp0, 'String'));
wingUp(2) = str2num(get(handles.WingUp1, 'String'));
wingUp(3) = str2num(get(handles.WingUp2, 'String'));
wingUp(4) = str2num(get(handles.WingUp3, 'String'));

footDown(1) = str2num(get(handles.FootDown0, 'String'));
footDown(2) = str2num(get(handles.FootDown1, 'String'));
footDown(3) = str2num(get(handles.FootDown2, 'String'));
footDown(4) = str2num(get(handles.FootDown3, 'String'));

footUp(1) = str2num(get(handles.FootUp0, 'String'));
footUp(2) = str2num(get(handles.FootUp1, 'String'));
footUp(3) = str2num(get(handles.FootUp2, 'String'));
footUp(4) = str2num(get(handles.FootUp3, 'String'));

period = str2num(get(handles.Period, 'String'));

%Calculate some useful variables
numLegs=4;
f=50;           %NOTE: Had to change? to 50Hz to work w/VM servo controller
N=f*period;     % Number of steps in the sequence (limited to 256 for ver3)
stepdur=1/f*1000;
%NOTE: The sequences can only be up to 256 frames for v3, 1024 for v2
if (version == 2)
    if (N > 1024)       
        stepdur=(period/1024);
        N=1024
    end
elseif (N > 256)  % Put everything else down to 256, to be safe.
    stepdur = (period/256);
    N = 256;
end


%% Setup the array of points of interest, without interpolation between
%% them
% Calculate the start load and end positions in servo control values
for i = 1:numLegs
    strokeTop(i) = zeroControlVal(i) + strokeStartAngle/radPerControlVal(i);
    loadShear(i) = zeroControlVal(i) + loadShearAngle/radPerControlVal(i);
    strokeBot(i) = zeroControlVal(i) + strokeEndAngle/radPerControlVal(i);
end

% Calcuate the time sequences.
strokeTime = mod([0; loadShearDC; strokeStart + strokeDC; strideStart; strideStart + strideDC], 1);
wingTime = mod([nominalStart; nominalStart + nominalDC; liftStart; liftStart + liftDC; loadNormStart - liftDC; loadNormStart; loadNormStart + loadNormDC], 1);
footTime = mod([curlStart; curlStart + curlDC; uncurlStart; uncurlStart + uncurlDC], 1);

% Set up the servo value sequences 
for i = 1:numLegs
    strokeVals(:,i) = [strokeTop(i) loadShear(i) strokeBot(i) strokeBot(i) strokeTop(i)]';
    wingVals(:,i) = [wingDown(i) wingNom(i) wingNom(i) wingUp(i) wingUp(i) wingNom(i) wingDown(i)]';
    footVals(:,i) = [footDown(i) footUp(i) footUp(i) footDown(i)]';
end

% Now, the time sequences above might not be increasing, so we need to sort
% them and the associated servo value sequences.
[strokeTime, indices] = sort(strokeTime);
strokeVals = strokeVals(indices,:);
[wingTime indices] = sort(wingTime);
wingVals = wingVals(indices,:);
[footTime indices] = sort(footTime);
footVals = footVals(indices,:);

% Add in values for 0 and 1 by interpolating
l = length(strokeTime);
stroke0Val = (strokeTime(1)*strokeVals(l,:) +...
    (1 - strokeTime(l))*strokeVals(1,:))/...
    mod(strokeTime(1) - strokeTime(l), 1);
l = length(wingTime);
wing0Val = (wingTime(1)*wingVals(l,:) + ...
    (1 - wingTime(l))*wingVals(1,:))/...
    mod(wingTime(1) - wingTime(l), 1);
l = length(footTime);
foot0Val = (footTime(1)*footVals(l,:) + ...
    (1 - footTime(l))*footVals(1,:))/...
    mod(footTime(1) - footTime(l), 1);
strokeTime = [0; strokeTime; 1];
wingTime = [0; wingTime; 1];
footTime = [0; footTime; 1];
strokeVals = [stroke0Val; strokeVals; stroke0Val];
wingVals = [wing0Val; wingVals; wing0Val];
footVals = [foot0Val; footVals; foot0Val];

% Remove duplicates from the time and value arrays
[strokeTime indices] = unique(strokeTime);
strokeVals = strokeVals(indices,:);
[wingTime indices] = unique(wingTime);
wingVals = wingVals(indices,:);
[footTime indices] = unique(footTime);
footVals = footVals(indices,:);


% Create the master time array
time = [];
for i = 1:numLegs
    time = [time mod([strokeTime wingTime footTime] + phase(i), 1)];
end
time = [unique(time) 1];

% Create the servo table by interpolating when needed at every point of
% interest.
for i = 1:length(time)-1    % -1 because we added 1 at the end of it
    for j = 1:numLegs
        phaseTime = mod(time(i) - phase(j), 1);
        
        % Wing angles:  find which interval we are currently in.
        index = max(find(wingTime <= phaseTime));
    
        % Interpolate within that interval if we need to
        servtab(i,3*j-2) = ((phaseTime - wingTime(index))*wingVals(index+1,j)...
            + (wingTime(index+1) - phaseTime)*wingVals(index,j))...
            /(wingTime(index+1) - wingTime(index));
        servtab(i,3*j-2) = round(servtab(i,3*j-2));
    
        % Stroke angles: find which interval we're currently in.
        index = max(find(strokeTime <= phaseTime));
    
        % Interpolate within that interval
        servtab(i,3*j-1) = ((phaseTime - strokeTime(index))*strokeVals(index+1,j)...
            + (strokeTime(index+1) - phaseTime)*strokeVals(index,j))...
            /(strokeTime(index+1) - strokeTime(index));
        servtab(i,3*j-1) = round(servtab(i,3*j-1));
    
        % Foot angles: find which interval we're currently in.
        index = max(find(footTime <= phaseTime));
     
        % Interpolate within that interval
        servtab(i,3*j) = ((phaseTime - footTime(index))*footVals(index+1,j)...
            + (footTime(index+1) - phaseTime)*footVals(index,j))...
            /(footTime(index+1) - footTime(index));
        servtab(i,3*j) = round(servtab(i,3*j));
    end
    % add the time interval (in nomalized timespace)
    servtab(i, 3*numLegs+1) = time(i+1) - time(i);
end

% Interpolate to every time step if we need to.
if (get(handles.Interpolation, 'Value') == get(handles.Interpolation, 'Max'))
    servtab = interpolate(servtab, N);
end

% Now convert the times to actual duration, not in the normalized
% timespace
servtab(:,3*numLegs+1) = servtab(:,3*numLegs+1)*period*1000;    % ideal duration in ms
servtab(:,3*numLegs+1) = round(servtab(:,3*numLegs+1)/stepdur)*stepdur;

% Now put everything in the right columns for the robot
dataout = ServoTrans(servtab);




function newTable = interpolate(oldTable, N)
% Interpolates a servo table into a total of N steps.

% Create an array of the normalized time, not just intervals.
time = [0; cumsum(oldTable(:,size(oldTable, 2)))];

% Add the start position at the end of the table for the interpolation
oldTable = [oldTable; oldTable(1,:)];

for i = 0:N-1
    currTime = i/N;    
    %% NOTE: Currently this assumes servos are numbered sequentially for
    %% each leg (ie. S0=leg 0 wing, S1=leg 0 stroke, S2=leg 0 foot
    %% actuation)
    
    % Find which interval we are currently in
    index = max(find(time <= currTime));
    
    % Interpolate within that interval.
    newTable(i+1,:) = ((currTime - time(index))*oldTable(index+1,:)...
                    + (time(index+1) - currTime)*oldTable(index,:))...
                    /(time(index+1) - time(index));
    
end

newTable = round(newTable);

% The time portion of the table is garbage at this point, but since we have
% the number of steps, we can reconstruct it.
newTable(:,size(newTable,2)) = ones(N,1)/N;



function [V I] = unique(vec)
% Returns the unique elements (unique being within 1e-10) of vector V, and
% the indices of those elements in the original vector.

% Sort first, so that checking for duplicates is easier
[vec indices] = sort(vec);

V = vec(1);
I = indices(1);
for i = 2:length(vec)
    if (abs(vec(i) - vec(i-1)) >= 1e-10)
        V = [V vec(i)];
        I = [I indices(i)];
    end
end



% SERVOTRANS will transform a servo sequence table to a form that matches
% the current wiring of Stickybot.  This is basically a column swapper.
% Example:    
%                    ************   
%            Leg 0   *          *   Leg 1
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%            Leg 2   *          *   Leg 3
%                    ************

function dataout=ServoTrans(datain)

%Legs are determined by columns of the following variables, ie. [0 1 2 3]
%  and the numbers are the servos numbered by the servo controller
%  software/hardware/firmware (#0-11)
% Now based on the new setup (as of 6/14/06)
FootServ=[0 1 2 3]+1;         %Add 1 to work w/Matlab matrices
StrokeServ=[4 5 6 7]+1;       %Add 1 to work w/Matlab matrices
WingServ=[8 9 10 11]+1;          %Add 1 to work w/Matlab matrices
numLegs=4;

%Build a new table of servo data
for i=1:numLegs
    dataout(:,WingServ(i))=datain(:,(i-1)*3+1);
    dataout(:,StrokeServ(i))=datain(:,(i-1)*3+2);
    dataout(:,FootServ(i))=datain(:,(i-1)*3+3);
end
%Add the step durations
dataout(:,13)=datain(:,13);

function nomElbowAngle3_Callback(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nomElbowAngle3 as text
%        str2double(get(hObject,'String')) returns contents of nomElbowAngle3 as a double


% --- Executes during object creation, after setting all properties.
function nomElbowAngle3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function nomElbowAngle2_Callback(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nomElbowAngle2 as text
%        str2double(get(hObject,'String')) returns contents of nomElbowAngle2 as a double


% --- Executes during object creation, after setting all properties.
function nomElbowAngle2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function nomElbowAngle1_Callback(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nomElbowAngle1 as text
%        str2double(get(hObject,'String')) returns contents of nomElbowAngle1 as a double


% --- Executes during object creation, after setting all properties.
function nomElbowAngle1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function nomElbowAngle0_Callback(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nomElbowAngle0 as text
%        str2double(get(hObject,'String')) returns contents of nomElbowAngle0 as a double


% --- Executes during object creation, after setting all properties.
function nomElbowAngle0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nomElbowAngle0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp3_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp3 as text
%        str2double(get(hObject,'String')) returns contents of FootUp3 as a double


% --- Executes during object creation, after setting all properties.
function FootUp3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp2_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp2 as text
%        str2double(get(hObject,'String')) returns contents of FootUp2 as a double


% --- Executes during object creation, after setting all properties.
function FootUp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp1_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp1 as text
%        str2double(get(hObject,'String')) returns contents of FootUp1 as a double


% --- Executes during object creation, after setting all properties.
function FootUp1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp0_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp0 as text
%        str2double(get(hObject,'String')) returns contents of FootUp0 as a double


% --- Executes during object creation, after setting all properties.
function FootUp0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown3_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown3 as text
%        str2double(get(hObject,'String')) returns contents of FootDown3 as a double


% --- Executes during object creation, after setting all properties.
function FootDown3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown2_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown2 as text
%        str2double(get(hObject,'String')) returns contents of FootDown2 as a double


% --- Executes during object creation, after setting all properties.
function FootDown2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown1_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown1 as text
%        str2double(get(hObject,'String')) returns contents of FootDown1 as a double


% --- Executes during object creation, after setting all properties.
function FootDown1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown0_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown0 as text
%        str2double(get(hObject,'String')) returns contents of FootDown0 as a double


% --- Executes during object creation, after setting all properties.
function FootDown0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function StrokeStartAngle_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeStartAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeStartAngle as text
%        str2double(get(hObject,'String')) returns contents of StrokeStartAngle as a double


% --- Executes during object creation, after setting all properties.
function StrokeStartAngle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStartAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function StrokeEndAngle_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeEndAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeEndAngle as text
%        str2double(get(hObject,'String')) returns contents of StrokeEndAngle as a double


% --- Executes during object creation, after setting all properties.
function StrokeEndAngle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeEndAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Import.
function Import_Callback(hObject, eventdata, handles)
% hObject    handle to Import (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file path] = uigetfile({'*.gpn', 'GPLAN Settings Files (*.gpn)'},...
    'Import GPLAN Settings from...');
if (isequal(file, 0))
    return;  % do nothing
end

% Get all the field names for the handles stuct.
fields = fieldnames(handles);

% Get all the values from the *.gpn file
values = load([path file]);

% See if this is a version 6 *.gpn file
if (values(1) ~= 6)
    errordlg('Selected file is from an old version of GPlan', 'Version Mismatch');
    return;
end

% Remove the versioning value
values = values(2:length(values));

% Index to keep track of where we are in the values array.
index = 0;

for i = 1:length(fields)
    fieldName = char(fields(i));
    
    % See if this is a uicontrol
    if (strcmp(get(handles.(fieldName), 'Type'), 'uicontrol') == 1)
    
        % See if this uicontrol is an editable text field.
        if (strcmp(get(handles.(fieldName), 'Style'), 'edit') == 1)
        
            % Increment the index within the values array.
            index = index + 1;
        
            % If that index is too large, there has been a formatting
            % problem in the *.gpn file.
            if index > length(values)
                disp('GPlan Settings file is incorrectly formatted.');
                return;
            end
        
            % Otherwise, set the string of the current uicontrol to the
            % current value from the values array.
            set(handles.(fieldName), 'String', num2str(values(index)));
        end
    end
end

% Call calculate (works because hObject and evendata aren't used in that
% function.
Calc_Callback(hObject, eventdata, handles);
UpdateSingleTraj(handles);
    


% --- Executes on button press in Export.
function Export_Callback(hObject, eventdata, handles)
% hObject    handle to Export (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file path] = uiputfile({'*.gpn', 'GPLAN Settings Files (*.gpn)'},...
    'Export GPLAN Settings to...');

if length(file)<=3
    file=[file '.gpn'];
else if strcmp(file(length(file)-3:length(file)),'.gpn')~=1
        file=[file '.gpn'];
    end
end

% Load the settings
fid = fopen([path file], 'w');

% write the versioning information
fprintf(fid, '6\n');

% Get all the field names for the handles struct.
fields = fieldnames(handles);

for i = 1:length(fields)
    fieldName = char(fields(i));
    
    % See if this is a uicontrol
    if (strcmp(get(handles.(fieldName), 'Type'), 'uicontrol') == 1)
    
        % See if this uicontrol is an editable text field.
        if (strcmp(get(handles.(fieldName), 'Style'), 'edit') == 1)
        
            % Write the value from the text field to the file.
            fprintf(fid, '%d\n', str2num(get(handles.(fieldName), 'String')));
        end
    end
end

% close the file
fclose(fid);


%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes during object creation, after setting all properties.
function LoadShearStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadShearStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called



function LoadShearDC_Callback(hObject, eventdata, handles)
% hObject    handle to LoadShearDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LoadShearDC as text
%        str2double(get(hObject,'String')) returns contents of LoadShearDC as a double

% Make sure the value entered is within the normalized timespace
loadShearDC = str2num(get(handles.LoadShearDC, 'String'));
loadShearDC = mod(loadShearDC, 1);
set(handles.LoadShearDC, 'String', num2str(loadShearDC));
set(handles.StrokeStart, 'String', num2str(loadShearDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function LoadShearDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadShearDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function StrokeStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


function StrokeDC_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeDC as text
%        str2double(get(hObject,'String')) returns contents of StrokeDC as a double

% Make sure the value entered is in the normalized time space.
strokeDC = str2num(get(handles.StrokeDC,'String'));
strokeDC = mod(strokeDC, 1);
set(handles.StrokeDC, 'String', num2str(strokeDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function StrokeDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrideDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrideStart_Callback(hObject, eventdata, handles)
% hObject    handle to LiftDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LiftDC as text
%        str2double(get(hObject,'String')) returns contents of LiftDC as a double

% Make sure the value entered is in the normalized time space.
strideStart = str2num(get(handles.StrideStart, 'String'));
strideStart = mod(strideStart, 1);
set(handles.StrideStart, 'String', num2str(strideStart));

%Update handles structure
guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function StrideStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LiftDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrideDC_Callback(hObject, eventdata, handles)
% hObject    handle to StrideDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrideDC as text
%        str2double(get(hObject,'String')) returns contents of StrideDC as a double

% Make sure the value entered is in the normalized time space.
strideDC = str2num(get(handles.StrideDC, 'String'));
strideDC = mod(strideDC, 1);
set(handles.StrideDC, 'String', num2str(strideDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function StrideDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrideDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function CurlStart_Callback(hObject, eventdata, handles)
% hObject    handle to edit70 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit70 as text
%        str2double(get(hObject,'String')) returns contents of edit70 as a double

% Make sure the value entered is in the normalized time space.
curlStart = str2num(get(handles.CurlStart, 'String'));
curlStart = mod(curlStart, 1);
set(handles.CurlStart, 'String', num2str(curlStart));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function CurlStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit70 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function CurlDC_Callback(hObject, eventdata, handles)
% hObject    handle to CurlDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of CurlDC as text
%        str2double(get(hObject,'String')) returns contents of CurlDC as a double

% Make sure the value entered is in the normalized time space.
curlDC = str2num(get(handles.CurlDC,'String'));
curlDC = mod(curlDC, 1);
set(handles.CurlDC, 'String', num2str(curlDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function CurlDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CurlDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function UncurlStart_Callback(hObject, eventdata, handles)
% hObject    handle to UncurlStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UncurlStart as text
%        str2double(get(hObject,'String')) returns contents of UncurlStart as a double

% Make sure the value entered is in the normalized time space.
uncurlStart = str2num(get(handles.UncurlStart,'String'));
uncurlStart = mod(uncurlStart, 1);
set(handles.UncurlStart, 'String', num2str(uncurlStart));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function UncurlStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UncurlStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function UncurlDC_Callback(hObject, eventdata, handles)
% hObject    handle to UncurlDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UncurlDC as text
%        str2double(get(hObject,'String')) returns contents of UncurlDC as a double

% Make sure the value entered is in the normalized time space.
uncurlDC = str2num(get(handles.UncurlDC, 'String'));
uncurlDC = mod(uncurlDC, 1);
set(handles.UncurlDC, 'String', num2str(uncurlDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function UncurlDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UncurlDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function LiftStart_Callback(hObject, eventdata, handles)
% hObject    handle to edit71 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit71 as text
%        str2double(get(hObject,'String')) returns contents of edit71 as a double

% Make sure the value entered is in the normalized time space.
liftStart = str2num(get(handles.LiftStart, 'String'));
liftStart = mod(liftStart, 1);
set(handles.LiftStart, 'String', num2str(liftStart));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function LiftStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit71 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function LiftDC_Callback(hObject, eventdata, handles)
% hObject    handle to LiftDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LiftDC as text
%        str2double(get(hObject,'String')) returns contents of LiftDC as a double

% Make sure the value entered is in the normalized time space.
liftDC = str2num(get(handles.LiftDC, 'String'));
liftDC = mod(liftDC, 1);
set(handles.LiftDC, 'String', num2str(liftDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function LiftDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LiftDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function LoadNormStart_Callback(hObject, eventdata, handles)
% hObject    handle to N (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of N as text
%        str2double(get(hObject,'String')) returns contents of N as a double

% Make sure the value entered is in the normalized time space.
loadNormStart = str2num(get(handles.LoadNormStart, 'String'));
loadNormStart = mod(loadNormStart, 1);
set(handles.LoadNormStart, 'String', num2str(loadNormStart));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function LoadNormStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to N (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function LoadNormDC_Callback(hObject, eventdata, handles)
% hObject    handle to LoadNormDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LoadNormDC as text
%        str2double(get(hObject,'String')) returns contents of LoadNormDC as a double

% Make sure the value entered is in the normalized time space.
loadNormDC = str2num(get(handles.LoadNormDC, 'String'));
loadNormDC = mod(loadNormDC, 1);
set(handles.LoadNormDC, 'String', num2str(loadNormDC));

% Update handles structure
guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function LoadNormDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadNormDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function NominalStart_Callback(hObject, eventdata, handles)
% hObject    handle to NominalStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NominalStart as text
%        str2double(get(hObject,'String')) returns contents of NominalStart as a double

% Make sure the value entered is in the normalized time space.
nominalStart = str2num(get(handles.NominalStart, 'String'));
nominalStart = mod(nominalStart, 1);
set(handles.NominalStart, 'String', num2str(nominalStart));

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function NominalStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NominalStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NominalDC_Callback(hObject, eventdata, handles)
% hObject    handle to NominalDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NominalDC as text
%        str2double(get(hObject,'String')) returns contents of NominalDC as a double

% Make sure the value entered is in the normalized time space.
nominalDC = str2num(get(handles.NominalDC, 'String'));
nominalDC = mod(nominalDC, 1);
set(handles.NominalDC, 'String', num2str(nominalDC));

% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function NominalDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NominalDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Interpolation.
function Interpolation_Callback(hObject, eventdata, handles)
% hObject    handle to Interpolation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Interpolation



function LoadShearAngle_Callback(hObject, eventdata, handles)
% hObject    handle to LoadShearAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LoadShearAngle as text
%        str2double(get(hObject,'String')) returns contents of LoadShearAngle as a double


% --- Executes during object creation, after setting all properties.
function LoadShearAngle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadShearAngle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end